Index: Makefile.am
===================================================================
RCS file: /sources/gnash/gnash/Makefile.am,v
retrieving revision 1.65
diff -u -r1.65 Makefile.am
--- Makefile.am	7 Mar 2007 15:11:24 -0000	1.65
+++ Makefile.am	31 Mar 2007 10:54:57 -0000
@@ -108,18 +108,15 @@
 
 # Set a few variables to what features we selected so we can dump it with the
 # test of the config
-if USE_SOUND_SDL
-  SOUND_OPT=sdl
-endif
 if USE_SOUND_GST
-  SOUND_OPT=gst
+  MEDIA_OPT=gst
 endif
 
 if USE_MAD_ENGINE
-  ENGINE_OPT=mad
+  MEDIA_OPT=mad
 endif
 if USE_FFMPEG_ENGINE
-  ENGINE_OPT=ffmpeg
+  MEDIA_OPT=ffmpeg
 endif
 
 if USE_GUI_GTK
@@ -252,7 +249,6 @@
 	@echo "legit value"
 	@echo ""
 	@echo "Configurable options are:"
-	@echo "Sound handler: $(SOUND_OPT)"
-	@echo "MP3 decoder: $(ENGINE_OPT)"
+	@echo "Media handler: $(MEDIA_OPT)"
 	@echo "Renderer engine: $(RENDER_OPT)"
 	@echo "GUI: $(GUI_OPT)"
Index: configure.ac
===================================================================
RCS file: /sources/gnash/gnash/configure.ac,v
retrieving revision 1.282
diff -u -r1.282 configure.ac
--- configure.ac	31 Mar 2007 04:54:31 -0000	1.282
+++ configure.ac	31 Mar 2007 10:54:58 -0000
@@ -260,41 +260,22 @@
 fi
 
 dnl --------------------------------------------------------
-dnl  Select sound streamer
+dnl  Select media handler
 dnl --------------------------------------------------------
 
 AC_ARG_ENABLE(sound,
- AC_HELP_STRING([--enable-sound=handler], [Enable sound support using the specified handler: SDL, GST (Gstreamer) or none (no sound) [[SDL]] ]),
+ AC_HELP_STRING([--enable-media=handler], [Enable media handling support using the specified handler: ffmpeg, mad, GST (Gstreamer) or none (no sound) [[ffmpeg]] ]),
  [case "${enableval}" in
-   GST|gst) sound_handler=gst ;;
-   sdl|SDL) sound_handler=sdl  ;;
-   no|NO|none) sound_handler=none ;;
-   *) AC_MSG_ERROR([bad value ${enableval} for --enable-sound option]) ;;
+   GST|gst) media_handler=gst ;;
+   ffmpeg|FFMPEG) media_handler=ffmpeg  ;;
+   mad|MAD) media_handler=mad  ;;
+   no|NO|none) media_handler=none ;;
+   *) AC_MSG_ERROR([bad value ${enableval} for --enable-media option]) ;;
   esac],
- [sound_handler=sdl]
+ [media_handler=ffmpeg]
 )
 
 dnl --------------------------------------------------------
-dnl  Select mp3 decoder (only for 'sdl' sound)
-dnl --------------------------------------------------------
-
-AC_ARG_WITH(mp3-decoder,
- AC_HELP_STRING([--with-mp3-decoder=DECODER], [Use the specified mp3 decoder: ffmpeg, mad (libmad) or none [[none]]]),
- [case "${withval}" in
-   ffmpeg|FFMPEG) mp3_decoder=ffmpeg ;;
-   mad|MAD) mp3_decoder=mad  ;;
-   no|none) mp3_decoder=none ;;
-   *) AC_MSG_ERROR([invalid mp3_decoder ${withval} given (accept: ffmpeg|mad)]) ;;
-  esac],
- [mp3_decoder=ffmpeg]
-)
-
-if test x"$sound_handler" != xsdl -a x"$mp3_decoder" != xnone; then
-mp3_decoder=none;
-	dnl AC_MSG_ERROR([--with-mp3-decoder is only valid with --enable-sound=sdl])
-fi
-
-dnl --------------------------------------------------------
 dnl  ...
 dnl --------------------------------------------------------
 
@@ -526,7 +507,7 @@
 dnl currently unused
 dnl GNASH_PKG_FIND(ogg, [ogg.h], [decode ogg streams], ogg_stream_init)
 
-if test x$gui = xsdl -o x$sound_handler = xsdl; then
+if test x$gui = xsdl -o x$media_handler = xffmpeg -o x$media_handler = xffmpeg; then
   GNASH_PATH_SDL
 fi
 
@@ -580,7 +561,7 @@
 AM_CONDITIONAL(opengl, [test x$opengl = xyes])
 
 dnl Need GLIB for both GTK and GST
-if test x${gui} = "xgtk" -o x${sound_handler} = "xgst"; then
+if test x${gui} = "xgtk" -o x${media_handler} = "xgst"; then
   GNASH_PATH_GLIB
 fi
 
@@ -664,53 +645,52 @@
   *)
 esac
 
-if test x"$mp3_decoder" = x"ffmpeg"; then
+if test x"$media_handler" = x"ffmpeg"; then
   GNASH_PATH_FFMPEG
   if test x"${ac_cv_path_ffmpeg_lib}" = x ; then
-    AC_MSG_WARN([ffmpeg specified as decoder, but it's not present, disabling sound])
-    mp3_decoder=none
-    sound_handler=none
+    AC_MSG_WARN([ffmpeg specified as decoder, but it's not present, disabling media handling])
+    media_handler=none
   fi
 fi
 
-if test x"$mp3_decoder" = x"mad"; then
+if test x"$media_handler" = x"mad"; then
   dnl Will set MAD_LIBS and MAD_CFLAGS.
   dnl Handles --with-mad-incl and --with-mad-lib
   GNASH_PKG_FIND(mad, [mad.h], [mad library], mad_copyright)
   if test x"${ac_cv_path_mad_lib}" = x ; then
-    mp3_decoder=none
-    sound_handler=none
-    AC_MSG_WARN([Libmad specified as decoder, but it's not present, disabling sound])
+    media_handler=none
+    AC_MSG_WARN([Libmad specified as decoder, but it's not present, disabling media handling])
   fi
 fi
 dnl I'm kinda lazy, get rid of this later... //Markus
-AM_CONDITIONAL(HAVE_MAD, test x$mp3_decoder = xmad)
+AM_CONDITIONAL(HAVE_MAD, test x$media_handler = xmad)
 
-AM_CONDITIONAL(USE_SOUND_GST, test x$sound_handler = xgst)
-AM_CONDITIONAL(USE_SOUND_SDL, test x$sound_handler = xsdl)
-AM_CONDITIONAL(USE_FFMPEG_ENGINE, test x$mp3_decoder = xffmpeg)
-AM_CONDITIONAL(USE_MAD_ENGINE, test x$mp3_decoder = xmad)
+AM_CONDITIONAL(USE_SOUND_GST, test x$media_handler = xgst)
+AM_CONDITIONAL(USE_SOUND_SDL, test x$media_handler = xmad -o x$media_handler = xffmpeg)
+AM_CONDITIONAL(USE_FFMPEG_ENGINE, test x$media_handler = xffmpeg)
+AM_CONDITIONAL(USE_MAD_ENGINE, test x$media_handler = xmad)
 
 dnl AM_CONDITIONAL(HAVE_FFMPEG, [test x"${FFMPEG_LIBS}" != x])
 
-case "${sound_handler}" in
-  gst) AC_DEFINE([SOUND_GST],  [1], [Use GSTREAMER for sound]) ;;
-  sdl) AC_DEFINE([SOUND_SDL],  [1], [Use SDL for sound]) ;;
+case "${media_handler}" in
+  gst) AC_DEFINE([SOUND_GST],  [1], [Use GSTREAMER for media handling]) ;;
+  ffmpeg) AC_DEFINE([SOUND_SDL],  [1], [Use SDL for sound handing]) ;;
+  mad) AC_DEFINE([SOUND_SDL],  [1], [Use SDL for sound handling]) ;;
   *)
 esac
 
-case "${mp3_decoder}" in
-  ffmpeg)  AC_DEFINE([USE_FFMPEG],  [1], [Use FFMPEG for mp3 decoding]) ;;
-  mad)  AC_DEFINE([USE_MAD],  [1], [Use MAD for mp3 decoding]) ;;
+case "${media_handler}" in
+  ffmpeg)  AC_DEFINE([USE_FFMPEG],  [1], [Use FFMPEG for media decoding]) ;;
+  mad)  AC_DEFINE([USE_MAD],  [1], [Use MAD for media decoding]) ;;
   *)
 esac
 
-if test "$sound_handler" = "gst"; then
+if test "$media_handler" = "gst"; then
   GNASH_PKG_FIND(gstreamer, [gst/gst.h], [gstreamer library], gst_init, [0.10])
 fi
 
 dnl I'm kinda lazy, get rid of this later... //Markus
-AM_CONDITIONAL(HAVE_GST, test x$sound_handler = xgst)
+AM_CONDITIONAL(HAVE_GST, test x$media_handler = xgst)
 
 if test x$gui = xfltk; then
   GNASH_PKG_FIND(fltk2, [fltk/FL_API.h], [Fast Light Toolkit], fl_window_flush)
@@ -870,10 +850,8 @@
 AC_SUBST(RENDERER_CONFIG)
 GUI_CONFIG=$gui
 AC_SUBST(GUI_CONFIG)
-SOUND_CONFIG=$sound_handler
-AC_SUBST(SOUND_CONFIG)
-DECODER_CONFIG=$mp3_decoder
-AC_SUBST(DECODER_CONFIG)
+MEDIA_CONFIG=$media_handler
+AC_SUBST(MEDIA_CONFIG)
 
 dnl AC_CONFIG_LINKS(doc/C/images)
 AC_CONFIG_LINKS(testsuite/libbase/gnashrc:testsuite/libbase/gnashrc.in)
@@ -982,9 +960,9 @@
 
 echo "        Renderer engine: "$renderer
 echo "        GUI: "$gui
-echo "        Sound handler: "$sound_handler
-if test x"$sound_handler" = xsdl; then
-echo "        MP3 decoder: "$mp3_decoder
+echo "        Media handler: "$media_handler
+if test x"$_handler" = xffmpeg -o x"$_handler" = xmad; then
+echo "        Using SDL for sound handling"
 fi
 
 echo ""
@@ -1208,7 +1186,7 @@
 
 fi #}
 
-if test "$sound_handler" = "gst"; then
+if test "$media_handler" = "gst"; then
   if test x"$GSTREAMER_LIBS" != x; then
     if test x"$GSTREAMER_CFLAGS" != x; then
       echo "        Gstreamer flags are: $GSTREAMER_CFLAGS"
@@ -1217,13 +1195,12 @@
     fi
       echo "        Gstreamer libs are: $GSTREAMER_LIBS"
   else
-    echo "        ERROR: gstreamer sound requested, but no gstreamer 0.10+ found"
+    echo "        ERROR: gstreamer media handling requested, but no gstreamer 0.10+ found"
     nogo=true
   fi
 fi
 
-if test "$sound_handler" = "sdl"; then
-  if test x"$mp3_decoder" = x"mad"; then
+  if test x"$media_handler" = x"mad"; then
     echo "        MP3 support enabled through libmad"
     if test x"$MAD_LIBS" != x; then
       if test x"$MAD_CFLAGS" != x; then
@@ -1236,12 +1213,12 @@
       echo "        ERROR: No libmad (mp3) development package installed!"
       echo "               You need to have the libmad development package installed"
       echo "               to enable mp3 decoding. You can either reconfigure using"
-      echo "               --with-mp3-decoder=ffmpeg to use ffmpeg or install libmad0-dev"
+      echo "               --media-handler=ffmpeg to use ffmpeg or install libmad0-dev"
       echo "               (using apt-get) or libmad (using yum)."
       nogo=true
     fi
   else
-    if test x"$mp3_decoder" = x"ffmpeg"; then
+    if test x"$media_handler" = x"ffmpeg"; then
       if test x${ffmpeg_version} != xok; then
          echo "        ERROR: You have version ${ffmpeg_version} of ffmpeg installed."
          echo "               This version of ffmpeg may not work!"
@@ -1249,7 +1226,7 @@
         nogo=true
       fi
       if test x"$FFMPEG_LIBS" != x; then
-        echo "        MP3 support enabled through ffmpeg"
+        echo "        MP3 and video support enabled through ffmpeg"
         if test x"$FFMPEG_CFLAGS" != x; then
           echo "        ffmpeg flags are: $FFMPEG_CFLAGS"
         else
@@ -1260,13 +1237,12 @@
         echo "        ERROR: No ffmpeg development package installed!"
         echo "               You need to have the ffmpeg development package installed"
         echo "               to enable mp3 decoding. You can either reconfigure using"
-        echo "               --with-mp3-decoder=mad to use libmad or install libavcodec-dev"
+        echo "               --media-handler=mad to use libmad or install libavcodec-dev"
         echo "               and libdts-dev (using apt-get) or <package_names_here> (using yum).".
         nogo=true
       fi
     fi
   fi
-fi
 
 if test "$renderer" = "cairo"; then
   if test x"$CAIRO_LIBS" != x; then
@@ -1334,7 +1310,7 @@
   fi
 fi
 
-if test x"$sound_handler" = x"sdl"; then
+if test x"$media_handler" = x"ffmpeg" -o x"$media_handler" = x"mad"; then
   if test x"$SDL_LIBS" != x; then
     echo "        SDL flags are: $SDL_CFLAGS"
     echo "        SDL libs are: $SDL_LIBS"
Index: gui/Makefile.am
===================================================================
RCS file: /sources/gnash/gnash/gui/Makefile.am,v
retrieving revision 1.60
diff -u -r1.60 Makefile.am
--- gui/Makefile.am	6 Mar 2007 18:06:13 -0000	1.60
+++ gui/Makefile.am	31 Mar 2007 10:54:58 -0000
@@ -178,8 +178,7 @@
 AM_CPPFLAGS += -DPKGDATADIR=\"$(pkgdatadir)\"
 AM_CPPFLAGS += -DRENDERER_CONFIG=\"$(RENDERER_CONFIG)\"
 AM_CPPFLAGS += -DGUI_CONFIG=\"$(GUI_CONFIG)\"
-AM_CPPFLAGS += -DSOUND_CONFIG=\"$(SOUND_CONFIG)\"
-AM_CPPFLAGS += -DDECODER_CONFIG=\"$(DECODER_CONFIG)\"
+AM_CPPFLAGS += -DMEDIA_CONFIG=\"$(MEDIA_CONFIG)\"
 AM_CPPFLAGS += -DTARGET_CONFIG=\"$(target)\"
 
 dist_images_DATA = images/gnash_128_96.ico images/GnashG.png
Index: gui/gnash.cpp
===================================================================
RCS file: /sources/gnash/gnash/gui/gnash.cpp,v
retrieving revision 1.66
diff -u -r1.66 gnash.cpp
--- gui/gnash.cpp	6 Mar 2007 18:06:13 -0000	1.66
+++ gui/gnash.cpp	31 Mar 2007 10:54:58 -0000
@@ -134,8 +134,7 @@
          << "   Target: " << TARGET_CONFIG << endl
          << "   Renderer: " << RENDERER_CONFIG
          << "   GUI: " << GUI_CONFIG
-         << "   Sound handler: " << SOUND_CONFIG
-         << "   Decoder: " << DECODER_CONFIG
+         << "   Media handler: " << MEDIA_CONFIG
          << endl;
 }
 
Index: gui/gtk.cpp
===================================================================
RCS file: /sources/gnash/gnash/gui/gtk.cpp,v
retrieving revision 1.79
diff -u -r1.79 gtk.cpp
--- gui/gtk.cpp	29 Mar 2007 23:55:49 -0000	1.79
+++ gui/gtk.cpp	31 Mar 2007 10:54:58 -0000
@@ -856,12 +856,8 @@
     comments += RENDERER_CONFIG;
     comments += "   GUI: ";
     comments += GUI_CONFIG; // gtk of course!
-    comments += "   Sound: ";
-    comments += SOUND_CONFIG;
-    if (SOUND_CONFIG != "none") {
-	comments += "   MP3 decoder: ";
-	comments += DECODER_CONFIG;
-    }
+    comments += "   Media: ";
+    comments += MEDIA_CONFIG;
     comments += ".";
 
     gtk_about_dialog_set_url_hook(NULL, NULL, NULL);