--- ../../../INSTALLED/freefont/sfd/FreeMono.sfd	2011-12-26 10:49:09.703011000 +0100
+++ FreeMono.sfd	2011-12-26 11:45:03.763010998 +0100
@@ -19,7 +19,7 @@
 OS2_WeightWidthSlopeOnly: 0
 OS2_UseTypoMetrics: 1
 CreationTime: 1203284335
-ModificationTime: 1323992703
+ModificationTime: 1324895970
 PfmFamily: 49
 TTFWeight: 400
 TTFWidth: 5
@@ -120,14 +120,14 @@
 LangName: 1026 "" "" "+BD0EPgRABDwEMAQ7BDUEPQAA" 
 LangName: 1069 "" "" "Arrunta" 
 LangName: 1033 "" "" "" "" "" "" "" "" "GNU" "" "" "https://savannah.gnu.org/projects/freefont/" "" "This computer font is part of GNU FreeFont.  It is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.+AAoACgAA-This font is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.+AAoACgAA-You should have received a copy of the GNU General Public License along with this font.  If not, see +AAoA    http://www.gnu.org/licenses/+AAoACgAA-As a special exception, if you create a document which uses this font, and embed this font or unaltered portions of this font into the document, this font does not by itself cause the resulting document to be covered by the GNU General Public License. This exception does not however invalidate any other reasons why the document might be covered by the GNU General Public License. If you modify this font, you may extend this exception to your version of the font, but you are not obligated to do so. If you do not wish to do so, delete this exception statement from your version." "http://www.gnu.org/copyleft/gpl.html" 
-GaspTable: 3 9 14 21 13 65535 15 1
+GaspTable: 3 9 14 21 13 65535 15
 Encoding: Custom
 UnicodeInterp: none
 NameList: Adobe Glyph List
 DisplaySize: -36
 AntiAlias: 1
 FitToEm: 1
-WinInfo: 11792 16 11
+WinInfo: 8058 34 15
 BeginPrivate: 9
 UniqueID 7 5020945
 BlueValues 23 [-20 0 417 437 563 583]
@@ -140,7 +140,7 @@
 ForceBold 5 false
 EndPrivate
 AnchorClass2: "above_arabic"  "'mark' Mark Positioning in Arabic subtable" "below_arabic"  "'mark' Mark Positioning in Arabic subtable" "arab_diacritic"  "'mkmk' Mark to Mark in Arabic subtable" "abovegk"  "'mark' Mark Positioning in Greek subtable" "below"  "'mark' Mark Positioning in Latin 1 subtable" "above"  "'mark' Mark Positioning in Latin 2 subtable" 
-BeginChars: 67329 4169
+BeginChars: 67329 4170
 
 StartChar: space
 Encoding: 32 32 0
@@ -51614,7 +51614,7 @@
 Fore
 SplineSet
 304 530 m 0
- 446 530 565 410 565 265 c 0
+ 446 530 565 410 565 265 c 4
  565 119 446 0 300 0 c 0
  153 0 35 119 35 267 c 0
  35 413 155 530 304 530 c 0
@@ -64578,7 +64578,7 @@
 StartChar: cruzeiro
 Encoding: 8354 8354 2750
 Width: 600
-Flags: HMW
+Flags: HMWO
 LayerCount: 2
 Fore
 SplineSet
@@ -95327,5 +95327,50 @@
 Refer: 9 41 S 1 0 0 1 151 0 2
 Validated: 32769
 EndChar
+
+StartChar: uni262D
+Encoding: 9773 9773 4169
+Width: 600
+VWidth: 0
+Flags: H
+LayerCount: 2
+Fore
+SplineSet
+565 32.3076171875 m 0
+ 565 18.4619140625 552.692382812 0 531.154296875 -1.5380859375 c 0
+ 525 -1.5380859375 519.615234375 1.5380859375 513.461914062 6.9228515625 c 2
+ 436.538085938 83.0771484375 l 1
+ 405 63.0771484375 368.077148438 53.0771484375 326.538085938 53.0771484375 c 0
+ 255 53.0771484375 199.615234375 87.6923828125 175.76953125 136.922851562 c 1
+ 161.154296875 123.077148438 l 1
+ 173.461914062 113.077148438 179.615234375 105.384765625 179.615234375 100 c 0
+ 179.615234375 91.5380859375 175.76953125 86.9228515625 167.307617188 86.9228515625 c 0
+ 159.615234375 86.9228515625 152.692382812 93.0771484375 145 104.615234375 c 1
+ 110.384765625 50 84.23046875 22.3076171875 65 22.3076171875 c 0
+ 46.5380859375 22.3076171875 35 36.9228515625 35 55.384765625 c 0
+ 35 86.9228515625 113.461914062 132.307617188 115.76953125 133.845703125 c 1
+ 103.461914062 143.077148438 97.3076171875 150.76953125 97.3076171875 156.922851562 c 0
+ 97.3076171875 163.845703125 105 169.23046875 111.154296875 169.23046875 c 0
+ 118.077148438 169.23046875 125 163.077148438 133.461914062 150.76953125 c 1
+ 169.615234375 185.384765625 l 1
+ 195 185.384765625 l 1
+ 221.154296875 142.307617188 259.615234375 120.76953125 308.077148438 120.76953125 c 0
+ 328.845703125 120.76953125 351.922851562 127.692382812 378.845703125 140.76953125 c 1
+ 204.23046875 316.154296875 l 1
+ 150.384765625 263.845703125 l 1
+ 82.6923828125 331.538085938 l 1
+ 195.76953125 443.845703125 l 1
+ 311.922851562 424.615234375 l 1
+ 247.307617188 359.23046875 l 1
+ 426.538085938 180 l 1
+ 450.384765625 201.538085938 461.922851562 233.845703125 461.922851562 276.154296875 c 0
+ 461.922851562 367.692382812 386.538085938 463.845703125 315 504.615234375 c 1
+ 318.077148438 511.538085938 l 1
+ 438.077148438 487.692382812 532.692382812 397.692382812 532.692382812 265.384765625 c 0
+ 532.692382812 203.845703125 515.76953125 157.692382812 481.922851562 126.154296875 c 1
+ 558.077148438 49.23046875 l 2
+ 562.692382812 45.384765625 565 40 565 32.3076171875 c 0
+EndSplineSet
+EndChar
 EndChars
 EndSplineFont