Index: FreeSerifBold.sfd
===================================================================
--- FreeSerifBold.sfd	(révision 2528)
+++ FreeSerifBold.sfd	(copie de travail)
@@ -109,12 +109,12 @@
 Lookup: 4 0 0 "'ccmp' glyph compos in Latin for Viet"  {"'ccmp' horn compos. in Latin for Viet"  "'ccmp' glyph compos. in Latin for Viet-1"  } ['ccmp' ('latn' <'dflt' > ) ]
 Lookup: 4 0 0 "'ccmp' accent compos. in Latin for Viet"  {"'ccmp' accent compos. in Latin for Viet"  } ['ccmp' ('latn' <'dflt' > ) ]
 Lookup: 1 0 0 "'locl' localized forms for Sami"  {"'locl' localized forms for Sami-1"  } ['locl' ('latn' <'ISM ' > 'latn' <'LSM ' > 'latn' <'NSM ' > 'latn' <'SKS ' > ) ]
-Lookup: 1 0 0 "'onum' oldstyle figures"  {"'onum' oldstyle figures" ("oldstyle" ) } ['onum' ('DFLT' <'dflt' > ) ]
-Lookup: 1 0 0 "'pnum' proportional-width numbers"  {"'pnum' proportional-width numbers-1"  } ['pnum' ('DFLT' <'dflt' > ) ]
-Lookup: 1 0 0 "'tnum' tabular numbers"  {"'tnum' tabular mumbers-1"  } ['tnum' ('DFLT' <'dflt' > ) ]
-Lookup: 1 0 0 "'lnum' lining figures"  {"'lnum' lining figures-1"  } ['lnum' ('DFLT' <'dflt' > ) ]
-Lookup: 4 8 0 "'frac' diagonal fractions"  {"'frac' diagonal fractions w/slash"  "'frac' diagonal fractions w/fraction"  } ['frac' ('DFLT' <'dflt' > ) ]
-Lookup: 1 0 0 "'zero' slashed zero"  {"'zero' slashed zero-1"  } ['zero' ('DFLT' <'dflt' > ) ]
+Lookup: 1 0 0 "'onum' oldstyle figures"  {"'onum' oldstyle figures" ("oldstyle" ) } ['onum' ('DFLT' <'dflt' > 'latn' <'dflt' > ) ]
+Lookup: 1 0 0 "'pnum' proportional-width numbers"  {"'pnum' proportional-width numbers-1"  } ['pnum' ('DFLT' <'dflt' > 'latn' <'dflt' > ) ]
+Lookup: 1 0 0 "'tnum' tabular numbers"  {"'tnum' tabular mumbers-1"  } ['tnum' ('DFLT' <'dflt' > 'latn' <'dflt' > ) ]
+Lookup: 1 0 0 "'lnum' lining figures"  {"'lnum' lining figures-1"  } ['lnum' ('DFLT' <'dflt' > 'latn' <'dflt' > ) ]
+Lookup: 4 8 0 "'frac' diagonal fractions"  {"'frac' diagonal fractions w/slash"  "'frac' diagonal fractions w/fraction"  } ['frac' ('DFLT' <'dflt' > 'latn' <'dflt' > ) ]
+Lookup: 1 0 0 "'zero' slashed zero"  {"'zero' slashed zero-1"  } ['zero' ('DFLT' <'dflt' > 'latn' <'dflt' > ) ]
 Lookup: 1 0 0 "'subs' subscript"  {"'subs' subscript-1" ("inferior" ) } ['subs' ('DFLT' <'dflt' > 'grek' <'dflt' > 'latn' <'dflt' > ) ]
 Lookup: 1 0 0 "'sups' superscript"  {"'sups' superscript-1" ("superior" ) } ['sups' ('DFLT' <'dflt' > 'grek' <'dflt' > 'latn' <'dflt' > ) ]
 Lookup: 4 0 0 "'dlig' discretionary ligatures in Armenian"  {"'dlig' discretionary ligatures in Armenian-1"  } ['dlig' ('armn' <'dflt' > ) ]
@@ -91039,7 +91039,6 @@
 EndSplineSet
 Validated: 3073
 Substitution2: "'lnum' lining figures-1" zero
-Substitution2: "'tnum' tabular mumbers-1" zero
 Substitution2: "'pnum' proportional-width numbers-1" oldprop.0
 EndChar
 
@@ -91066,7 +91065,6 @@
 EndSplineSet
 Validated: 3073
 Substitution2: "'lnum' lining figures-1" one
-Substitution2: "'tnum' tabular mumbers-1" one
 Substitution2: "'pnum' proportional-width numbers-1" oldprop.1
 EndChar
 
@@ -91094,7 +91092,6 @@
 EndSplineSet
 Validated: 3073
 Substitution2: "'lnum' lining figures-1" two
-Substitution2: "'tnum' tabular mumbers-1" two
 Substitution2: "'pnum' proportional-width numbers-1" oldprop.2
 EndChar
 
@@ -91125,7 +91122,6 @@
 EndSplineSet
 Validated: 3073
 Substitution2: "'lnum' lining figures-1" three
-Substitution2: "'tnum' tabular mumbers-1" three
 Substitution2: "'pnum' proportional-width numbers-1" oldprop.3
 EndChar
 
@@ -91155,7 +91151,6 @@
 EndSplineSet
 Validated: 3073
 Substitution2: "'lnum' lining figures-1" four
-Substitution2: "'tnum' tabular mumbers-1" four
 Substitution2: "'pnum' proportional-width numbers-1" oldprop.4
 EndChar
 
@@ -91185,7 +91180,6 @@
 EndSplineSet
 Validated: 3073
 Substitution2: "'lnum' lining figures-1" five
-Substitution2: "'tnum' tabular mumbers-1" five
 Substitution2: "'pnum' proportional-width numbers-1" oldprop.5
 EndChar
 
@@ -91198,7 +91192,6 @@
 Refer: 22 54 N 1 0 0 1 0 0 2
 Validated: 32769
 Substitution2: "'lnum' lining figures-1" six
-Substitution2: "'tnum' tabular mumbers-1" six
 Substitution2: "'pnum' proportional-width numbers-1" oldprop.6
 EndChar
 
@@ -91221,7 +91214,6 @@
 EndSplineSet
 Validated: 3073
 Substitution2: "'lnum' lining figures-1" seven
-Substitution2: "'tnum' tabular mumbers-1" seven
 Substitution2: "'pnum' proportional-width numbers-1" oldprop.7
 EndChar
 
@@ -91234,7 +91226,6 @@
 Refer: 24 56 N 1 0 0 1 0 0 2
 Validated: 32769
 Substitution2: "'lnum' lining figures-1" eight
-Substitution2: "'tnum' tabular mumbers-1" eight
 Substitution2: "'pnum' proportional-width numbers-1" oldprop.8
 EndChar
 
@@ -91247,7 +91238,6 @@
 Refer: 25 57 N 1 0 0 1 0 -215 2
 Validated: 32769
 Substitution2: "'lnum' lining figures-1" nine
-Substitution2: "'tnum' tabular mumbers-1" nine
 Substitution2: "'pnum' proportional-width numbers-1" oldprop.9
 EndChar
 
@@ -91259,7 +91249,8 @@
 Fore
 Refer: 16 48 N 1 0 0 1 11 0 2
 Validated: 32769
-Substitution2: "'lnum' lining figures-1" zero
+Substitution2: "'onum' oldstyle figures" oldprop.0
+Substitution2: "'zero' slashed zero-1" zeroslashed
 Substitution2: "'tnum' tabular mumbers-1" zero
 EndChar
 
@@ -91271,7 +91262,7 @@
 Fore
 Refer: 17 49 N 1 0 0 1 -45 0 2
 Validated: 32769
-Substitution2: "'lnum' lining figures-1" one
+Substitution2: "'onum' oldstyle figures" oldprop.1
 Substitution2: "'tnum' tabular mumbers-1" one
 EndChar
 
@@ -91283,7 +91274,7 @@
 Fore
 Refer: 18 50 N 1 0 0 1 13 0 2
 Validated: 32769
-Substitution2: "'lnum' lining figures-1" two
+Substitution2: "'onum' oldstyle figures" oldprop.2
 Substitution2: "'tnum' tabular mumbers-1" two
 EndChar
 
@@ -91295,7 +91286,7 @@
 Fore
 Refer: 19 51 N 1 0 0 1 4 0 2
 Validated: 32769
-Substitution2: "'lnum' lining figures-1" three
+Substitution2: "'onum' oldstyle figures" oldprop.3
 Substitution2: "'tnum' tabular mumbers-1" three
 EndChar
 
@@ -91307,7 +91298,7 @@
 Fore
 Refer: 20 52 N 1 0 0 1 6 0 2
 Validated: 32769
-Substitution2: "'lnum' lining figures-1" four
+Substitution2: "'onum' oldstyle figures" oldprop.4
 Substitution2: "'tnum' tabular mumbers-1" four
 EndChar
 
@@ -91319,7 +91310,7 @@
 Fore
 Refer: 21 53 N 1 0 0 1 -2 0 2
 Validated: 32769
-Substitution2: "'lnum' lining figures-1" five
+Substitution2: "'onum' oldstyle figures" oldprop.5
 Substitution2: "'tnum' tabular mumbers-1" five
 EndChar
 
@@ -91331,7 +91322,7 @@
 Fore
 Refer: 22 54 N 1 0 0 1 2 0 2
 Validated: 32769
-Substitution2: "'lnum' lining figures-1" six
+Substitution2: "'onum' oldstyle figures" oldprop.6
 Substitution2: "'tnum' tabular mumbers-1" six
 EndChar
 
@@ -91343,7 +91334,7 @@
 Fore
 Refer: 23 55 N 1 0 0 1 -2 0 2
 Validated: 32769
-Substitution2: "'lnum' lining figures-1" seven
+Substitution2: "'onum' oldstyle figures" oldprop.7
 Substitution2: "'tnum' tabular mumbers-1" seven
 EndChar
 
@@ -91355,7 +91346,7 @@
 Fore
 Refer: 24 56 N 1 0 0 1 2 0 2
 Validated: 32769
-Substitution2: "'lnum' lining figures-1" eight
+Substitution2: "'onum' oldstyle figures" oldprop.8
 Substitution2: "'tnum' tabular mumbers-1" eight
 EndChar
 
@@ -91367,7 +91358,7 @@
 Fore
 Refer: 25 57 N 1 0 0 1 4 0 2
 Validated: 32769
-Substitution2: "'lnum' lining figures-1" nine
+Substitution2: "'onum' oldstyle figures" oldprop.9
 Substitution2: "'tnum' tabular mumbers-1" nine
 EndChar
 
@@ -91379,8 +91370,8 @@
 Fore
 Refer: 3973 -1 N 1 0 0 1 1 0 2
 Validated: 32769
-Substitution2: "'lnum' lining figures-1" zero
-Substitution2: "'tnum' tabular mumbers-1" zero
+Substitution2: "'lnum' lining figures-1" fit.0
+Substitution2: "'tnum' tabular mumbers-1" old.0
 EndChar
 
 StartChar: oldprop.1
@@ -91391,8 +91382,8 @@
 Fore
 Refer: 3974 -1 N 1 0 0 1 -45 0 2
 Validated: 32769
-Substitution2: "'lnum' lining figures-1" one
-Substitution2: "'tnum' tabular mumbers-1" one
+Substitution2: "'lnum' lining figures-1" fit.1
+Substitution2: "'tnum' tabular mumbers-1" old.1
 EndChar
 
 StartChar: oldprop.2
@@ -91403,8 +91394,8 @@
 Fore
 Refer: 3975 -1 N 1 0 0 1 3 0 2
 Validated: 32769
-Substitution2: "'lnum' lining figures-1" two
-Substitution2: "'tnum' tabular mumbers-1" two
+Substitution2: "'lnum' lining figures-1" fit.2
+Substitution2: "'tnum' tabular mumbers-1" old.2
 EndChar
 
 StartChar: oldprop.3
@@ -91415,8 +91406,8 @@
 Fore
 Refer: 3976 -1 N 1 0 0 1 0 0 2
 Validated: 32769
-Substitution2: "'lnum' lining figures-1" three
-Substitution2: "'tnum' tabular mumbers-1" three
+Substitution2: "'lnum' lining figures-1" fit.3
+Substitution2: "'tnum' tabular mumbers-1" old.3
 EndChar
 
 StartChar: oldprop.4
@@ -91427,8 +91418,8 @@
 Fore
 Refer: 3977 -1 N 1 0 0 1 1 0 2
 Validated: 32769
-Substitution2: "'lnum' lining figures-1" four
-Substitution2: "'tnum' tabular mumbers-1" four
+Substitution2: "'lnum' lining figures-1" fit.4
+Substitution2: "'tnum' tabular mumbers-1" old.4
 EndChar
 
 StartChar: oldprop.5
@@ -91439,8 +91430,8 @@
 Fore
 Refer: 3978 -1 N 1 0 0 1 0 0 2
 Validated: 32769
-Substitution2: "'lnum' lining figures-1" five
-Substitution2: "'tnum' tabular mumbers-1" five
+Substitution2: "'lnum' lining figures-1" fit.5
+Substitution2: "'tnum' tabular mumbers-1" old.5
 EndChar
 
 StartChar: oldprop.6
@@ -91451,8 +91442,8 @@
 Fore
 Refer: 3979 -1 N 1 0 0 1 2 0 2
 Validated: 32769
-Substitution2: "'lnum' lining figures-1" six
-Substitution2: "'tnum' tabular mumbers-1" six
+Substitution2: "'lnum' lining figures-1" fit.6
+Substitution2: "'tnum' tabular mumbers-1" old.6
 EndChar
 
 StartChar: oldprop.7
@@ -91463,8 +91454,8 @@
 Fore
 Refer: 23 55 N 1 0 0 1 -2 -212 2
 Validated: 32769
-Substitution2: "'lnum' lining figures-1" seven
-Substitution2: "'tnum' tabular mumbers-1" seven
+Substitution2: "'lnum' lining figures-1" fit.7
+Substitution2: "'tnum' tabular mumbers-1" old.7
 EndChar
 
 StartChar: oldprop.8
@@ -91475,8 +91466,8 @@
 Fore
 Refer: 3981 -1 N 1 0 0 1 2 0 2
 Validated: 32769
-Substitution2: "'lnum' lining figures-1" eight
-Substitution2: "'tnum' tabular mumbers-1" eight
+Substitution2: "'lnum' lining figures-1" fit.8
+Substitution2: "'tnum' tabular mumbers-1" old.8
 EndChar
 
 StartChar: oldprop.9
@@ -91487,8 +91478,8 @@
 Fore
 Refer: 3982 -1 N 1 0 0 1 4 0 2
 Validated: 32769
-Substitution2: "'lnum' lining figures-1" nine
-Substitution2: "'tnum' tabular mumbers-1" nine
+Substitution2: "'lnum' lining figures-1" fit.9
+Substitution2: "'tnum' tabular mumbers-1" old.9
 EndChar
 
 StartChar: zeroslashed
@@ -116493,6 +116484,8 @@
 Refer: 1337 8543 N 1 0 0 1 0 0 0
 Refer: 1445 8311 N 1.01003 0 0 1 487.9 -390 0
 Validated: 32769
+Ligature2: "'frac' diagonal fractions w/fraction" one fraction seven
+Ligature2: "'frac' diagonal fractions w/slash" one slash seven
 LCarets2: 2 0 0 
 Ligature2: "FreeSerif-'frac' diagonal fractions w/fraction" one fraction seven
 Ligature2: "FreeSerif-'frac' diagonal fractions w/slash-1" one slash seven
@@ -116501,12 +116494,14 @@
 StartChar: oneninth
 Encoding: 8529 8529 4625
 Width: 800
-Flags: HW
+Flags: W
 LayerCount: 2
 Fore
 Refer: 1337 8543 N 1 0 0 1 0 0 0
 Refer: 1450 8313 N 1 0 0 1 474 -388 2
 Validated: 32769
+Ligature2: "'frac' diagonal fractions w/fraction" one fraction nine
+Ligature2: "'frac' diagonal fractions w/slash" one slash nine
 LCarets2: 2 0 0 
 Ligature2: "FreeSerif-'frac' diagonal fractions w/slash-1" one slash nine
 Ligature2: "FreeSerif-'frac' diagonal fractions w/fraction" one fraction nine
@@ -116522,6 +116517,8 @@
 Refer: 118 185 N 1 0 0 1 460 -390 2
 Refer: 1449 8304 N 1 0 0 1 713 -388 2
 Validated: 32769
+Ligature2: "'frac' diagonal fractions w/fraction" one fraction one zero
+Ligature2: "'frac' diagonal fractions w/slash" one slash one zero
 LCarets2: 3 0 0 0 
 Ligature2: "FreeSerif-'frac' diagonal fractions w/slash-1" one slash one zero
 Ligature2: "FreeSerif-'frac' diagonal fractions w/fraction" one fraction one zero
@@ -116530,13 +116527,15 @@
 StartChar: zerothirds
 Encoding: 8585 8585 4627
 Width: 800
-Flags: HW
+Flags: W
 LayerCount: 2
 Fore
 Refer: 1433 8725 N 1 0 0 1 125 0 0
 Refer: 112 179 N 1 0 0 1 473 -395 0
 Refer: 1449 8304 N 1 0 0 1 10 -120 2
 Validated: 32769
+Ligature2: "'frac' diagonal fractions w/fraction" zero fraction three
+Ligature2: "'frac' diagonal fractions w/slash" zero slash three
 EndChar
 
 StartChar: uni037b
Index: FreeSerifBold.sfd
===================================================================
--- FreeSerifBold.sfd	(révision 2528)
+++ FreeSerifBold.sfd	(copie de travail)