Index: FreeSerif.sfd
===================================================================
--- FreeSerif.sfd	(révision 2528)
+++ FreeSerif.sfd	(copie de travail)
@@ -199,12 +199,12 @@
 Lookup: 4 0 0 "'hlig' hist. ligatures in Latin"  {"'hlig' hist. ligatures in Latin-1"  } ['hlig' ('latn' <'dflt' > ) ]
 Lookup: 4 0 0 "'hlig' hist. ligatures in Latin for German"  {"'hlig' hist. ligatures in Latin for German-1"  } ['hlig' ('latn' <'DEU ' > ) ]
 Lookup: 1 0 0 "'locl' localized forms for Sami"  {"'locl' localized forms for Sami-1"  } ['locl' ('latn' <'ISM ' > 'latn' <'LSM ' > 'latn' <'NSM ' > 'latn' <'SKS ' > ) ]
-Lookup: 1 0 0 "'onum' oldstyle figures"  {"'onum' oldstyle figures-1" ("oldstyle" ) } ['onum' ('DFLT' <'dflt' > ) ]
-Lookup: 1 0 0 "'pnum' proportional-width numbers"  {"'pnum' proportional-width numbers-1"  } ['pnum' ('DFLT' <'dflt' > ) ]
-Lookup: 1 0 0 "'tnum' tabular numbers"  {"'tnum' tabular numbers-1"  } ['tnum' ('DFLT' <'dflt' > ) ]
-Lookup: 1 0 0 "'lnum' lining figures"  {"'lnum' lining figures-1"  } ['lnum' ('DFLT' <'dflt' > ) ]
-Lookup: 4 0 0 "'frac' diagonal fractions"  {"'frac' diagonal fractions w/slash-1"  "'frac' diagonal fractions w/fraction"  } ['frac' ('DFLT' <'dflt' > ) ]
-Lookup: 1 0 0 "'zero' slashed zero"  {"'zero' slashed zero-1"  } ['zero' ('DFLT' <'dflt' > ) ]
+Lookup: 1 0 0 "'onum' oldstyle figures"  {"'onum' oldstyle figures-1" ("oldstyle" ) } ['onum' ('DFLT' <'dflt' > 'latn' <'dflt' > ) ]
+Lookup: 1 0 0 "'pnum' proportional-width numbers"  {"'pnum' proportional-width numbers-1"  } ['pnum' ('DFLT' <'dflt' > 'latn' <'dflt' > ) ]
+Lookup: 1 0 0 "'tnum' tabular numbers"  {"'tnum' tabular numbers-1"  } ['tnum' ('DFLT' <'dflt' > 'latn' <'dflt' > ) ]
+Lookup: 1 0 0 "'lnum' lining figures"  {"'lnum' lining figures-1"  } ['lnum' ('DFLT' <'dflt' > 'latn' <'dflt' > ) ]
+Lookup: 4 0 0 "'frac' diagonal fractions"  {"'frac' diagonal fractions w/slash-1"  "'frac' diagonal fractions w/fraction"  } ['frac' ('DFLT' <'dflt' > 'latn' <'dflt' > ) ]
+Lookup: 1 0 0 "'zero' slashed zero"  {"'zero' slashed zero-1"  } ['zero' ('DFLT' <'dflt' > 'latn' <'dflt' > ) ]
 Lookup: 1 0 0 "'sups' superscript"  {"'sups' superscript-1" ("superior" ) } ['sups' ('DFLT' <'dflt' > 'arab' <'dflt' > 'grek' <'dflt' > 'latn' <'dflt' > ) ]
 Lookup: 1 0 0 "'subs' subscript"  {"'subs' subscript-1" ("inferior" ) } ['subs' ('DFLT' <'dflt' > 'arab' <'dflt' > 'grek' <'dflt' > 'latn' <'dflt' > ) ]
 Lookup: 1 0 0 "'aalt' access-all-alternates in Greek"  {"'aalt' access-all-alternates in Greek-1"  } ['aalt' ('grek' <'dflt' > ) ]
@@ -2144,6 +2144,9 @@
  380 537 335 650 251 650 c 0
 EndSplineSet
 Validated: 1
+Substitution2: "'pnum' proportional-width numbers-1" fit.0
+Substitution2: "'onum' oldstyle figures-1" old.0
+Substitution2: "'zero' slashed zero-1" zeroslashed
 EndChar
 
 StartChar: one
@@ -2168,6 +2171,8 @@
  213 578 204 593 183 593 c 0
 EndSplineSet
 Validated: 1
+Substitution2: "'pnum' proportional-width numbers-1" fit.1
+Substitution2: "'onum' oldstyle figures-1" old.1
 EndChar
 
 StartChar: two
@@ -2195,6 +2200,8 @@
  31 477 l 1
 EndSplineSet
 Validated: 1
+Substitution2: "'pnum' proportional-width numbers-1" fit.2
+Substitution2: "'onum' oldstyle figures-1" old.2
 EndChar
 
 StartChar: three
@@ -2222,6 +2229,8 @@
  43 64 58 78 81 78 c 0
 EndSplineSet
 Validated: 1
+Substitution2: "'pnum' proportional-width numbers-1" fit.3
+Substitution2: "'onum' oldstyle figures-1" old.3
 EndChar
 
 StartChar: four
@@ -2249,6 +2258,8 @@
  292 231 l 1
 EndSplineSet
 Validated: 1
+Substitution2: "'pnum' proportional-width numbers-1" fit.4
+Substitution2: "'onum' oldstyle figures-1" old.4
 EndChar
 
 StartChar: five
@@ -2278,6 +2289,8 @@
  296 23 357 98 357 194 c 0
 EndSplineSet
 Validated: 1
+Substitution2: "'pnum' proportional-width numbers-1" fit.5
+Substitution2: "'onum' oldstyle figures-1" old.5
 EndChar
 
 StartChar: six
@@ -2302,6 +2315,8 @@
  378 310 328 382 242 382 c 0
 EndSplineSet
 Validated: 1
+Substitution2: "'pnum' proportional-width numbers-1" fit.6
+Substitution2: "'onum' oldstyle figures-1" old.6
 EndChar
 
 StartChar: seven
@@ -2323,6 +2338,8 @@
  449 662 l 1
 EndSplineSet
 Validated: 1
+Substitution2: "'pnum' proportional-width numbers-1" fit.7
+Substitution2: "'onum' oldstyle figures-1" old.7
 EndChar
 
 StartChar: eight
@@ -2353,6 +2370,8 @@
  136 493 172 447 261 389 c 1
 EndSplineSet
 Validated: 1
+Substitution2: "'pnum' proportional-width numbers-1" fit.8
+Substitution2: "'onum' oldstyle figures-1" old.8
 EndChar
 
 StartChar: nine
@@ -2378,6 +2397,8 @@
  122 355 170 280 246 280 c 0
 EndSplineSet
 Validated: 1
+Substitution2: "'pnum' proportional-width numbers-1" fit.9
+Substitution2: "'onum' oldstyle figures-1" old.9
 EndChar
 
 StartChar: colon
@@ -244834,6 +244855,8 @@
 Refer: 112 179 S 1 0 0 1 444 -395 0
 Refer: 2154 8260 N 1 0 0 1 290 0 0
 Validated: 1
+Ligature2: "'frac' diagonal fractions w/fraction" zero fraction three
+Ligature2: "'frac' diagonal fractions w/slash-1" zero slash three
 EndChar
 
 StartChar: oneseventh
@@ -251960,7 +251983,6 @@
 Validated: 1
 Substitution2: "'pnum' proportional-width numbers-1" oldprop.0
 Substitution2: "'lnum' lining figures-1" zero
-Substitution2: "'tnum' tabular numbers-1" zero
 EndChar
 
 StartChar: old.1
@@ -251987,7 +252009,6 @@
 Validated: 1
 Substitution2: "'pnum' proportional-width numbers-1" oldprop.1
 Substitution2: "'lnum' lining figures-1" one
-Substitution2: "'tnum' tabular numbers-1" one
 EndChar
 
 StartChar: old.2
@@ -252017,7 +252038,6 @@
 Validated: 1
 Substitution2: "'pnum' proportional-width numbers-1" oldprop.2
 Substitution2: "'lnum' lining figures-1" two
-Substitution2: "'tnum' tabular numbers-1" two
 EndChar
 
 StartChar: old.3
@@ -252047,7 +252067,6 @@
 Validated: 1
 Substitution2: "'pnum' proportional-width numbers-1" oldprop.3
 Substitution2: "'lnum' lining figures-1" three
-Substitution2: "'tnum' tabular numbers-1" three
 EndChar
 
 StartChar: old.4
@@ -252077,7 +252096,6 @@
 Validated: 1
 Substitution2: "'pnum' proportional-width numbers-1" oldprop.4
 Substitution2: "'lnum' lining figures-1" four
-Substitution2: "'tnum' tabular numbers-1" four
 EndChar
 
 StartChar: old.5
@@ -252109,7 +252127,6 @@
 Validated: 1
 Substitution2: "'pnum' proportional-width numbers-1" oldprop.5
 Substitution2: "'lnum' lining figures-1" five
-Substitution2: "'tnum' tabular numbers-1" five
 EndChar
 
 StartChar: old.6
@@ -252122,7 +252139,6 @@
 Validated: 1
 Substitution2: "'pnum' proportional-width numbers-1" oldprop.6
 Substitution2: "'lnum' lining figures-1" six
-Substitution2: "'tnum' tabular numbers-1" six
 EndChar
 
 StartChar: old.7
@@ -252135,7 +252151,6 @@
 Validated: 1
 Substitution2: "'pnum' proportional-width numbers-1" oldprop.7
 Substitution2: "'lnum' lining figures-1" seven
-Substitution2: "'tnum' tabular numbers-1" seven
 EndChar
 
 StartChar: old.8
@@ -252148,7 +252163,6 @@
 Validated: 1
 Substitution2: "'pnum' proportional-width numbers-1" oldprop.8
 Substitution2: "'lnum' lining figures-1" eight
-Substitution2: "'tnum' tabular numbers-1" eight
 EndChar
 
 StartChar: old.9
@@ -252161,7 +252175,6 @@
 Validated: 1
 Substitution2: "'pnum' proportional-width numbers-1" oldprop.9
 Substitution2: "'lnum' lining figures-1" nine
-Substitution2: "'tnum' tabular numbers-1" nine
 EndChar
 
 StartChar: zwarakayarabic
@@ -255004,10 +255017,9 @@
 Fore
 Refer: 16 48 N 1 0 0 1 11 0 2
 Validated: 1
-Substitution2: "'lnum' lining figures-1" zero
 Substitution2: "'tnum' tabular numbers-1" zero
 Substitution2: "'zero' slashed zero-1" zeroslashed
-Substitution2: "'onum' oldstyle figures-1" old.0
+Substitution2: "'onum' oldstyle figures-1" oldprop.0
 EndChar
 
 StartChar: fit.6
@@ -255018,9 +255030,8 @@
 Fore
 Refer: 22 54 N 1 0 0 1 1 0 2
 Validated: 1
-Substitution2: "'lnum' lining figures-1" six
 Substitution2: "'tnum' tabular numbers-1" six
-Substitution2: "'onum' oldstyle figures-1" old.6
+Substitution2: "'onum' oldstyle figures-1" oldprop.6
 EndChar
 
 StartChar: fit.7
@@ -255031,9 +255042,8 @@
 Fore
 Refer: 23 55 N 1 0 0 1 0 0 2
 Validated: 1
-Substitution2: "'lnum' lining figures-1" seven
 Substitution2: "'tnum' tabular numbers-1" seven
-Substitution2: "'onum' oldstyle figures-1" old.7
+Substitution2: "'onum' oldstyle figures-1" oldprop.7
 EndChar
 
 StartChar: fit.8
@@ -255044,9 +255054,8 @@
 Fore
 Refer: 24 56 N 1 0 0 1 -21 0 2
 Validated: 1
-Substitution2: "'lnum' lining figures-1" eight
 Substitution2: "'tnum' tabular numbers-1" eight
-Substitution2: "'onum' oldstyle figures-1" old.8
+Substitution2: "'onum' oldstyle figures-1" oldprop.8
 EndChar
 
 StartChar: fit.9
@@ -255057,9 +255066,8 @@
 Fore
 Refer: 25 57 N 1 0 0 1 5 0 2
 Validated: 1
-Substitution2: "'lnum' lining figures-1" nine
 Substitution2: "'tnum' tabular numbers-1" nine
-Substitution2: "'onum' oldstyle figures-1" old.9
+Substitution2: "'onum' oldstyle figures-1" oldprop.9
 EndChar
 
 StartChar: oldprop.0
@@ -255070,8 +255078,8 @@
 Fore
 Refer: 8007 -1 N 1 0 0 1 11 0 2
 Validated: 1
-Substitution2: "'tnum' tabular numbers-1" zero
-Substitution2: "'lnum' lining figures-1" zero
+Substitution2: "'tnum' tabular numbers-1" old.0
+Substitution2: "'lnum' lining figures-1" fit.0
 EndChar
 
 StartChar: oldprop.1
@@ -255082,8 +255090,8 @@
 Fore
 Refer: 8008 -1 N 1 0 0 1 -96 0 2
 Validated: 1
-Substitution2: "'tnum' tabular numbers-1" one
-Substitution2: "'lnum' lining figures-1" one
+Substitution2: "'tnum' tabular numbers-1" old.1
+Substitution2: "'lnum' lining figures-1" fit.1
 EndChar
 
 StartChar: oldprop.2
@@ -255094,8 +255102,8 @@
 Fore
 Refer: 8009 -1 N 1 0 0 1 -10 0 2
 Validated: 1
-Substitution2: "'tnum' tabular numbers-1" two
-Substitution2: "'lnum' lining figures-1" two
+Substitution2: "'tnum' tabular numbers-1" old.2
+Substitution2: "'lnum' lining figures-1" fit.2
 EndChar
 
 StartChar: oldprop.3
@@ -255106,8 +255114,8 @@
 Fore
 Refer: 8010 -1 N 1 0 0 1 -5 0 2
 Validated: 1
-Substitution2: "'lnum' lining figures-1" three
-Substitution2: "'tnum' tabular numbers-1" three
+Substitution2: "'lnum' lining figures-1" fit.3
+Substitution2: "'tnum' tabular numbers-1" old.3
 EndChar
 
 StartChar: oldprop.4
@@ -255118,8 +255126,8 @@
 Fore
 Refer: 8011 -1 N 1 0 0 1 -8 0 2
 Validated: 1
-Substitution2: "'tnum' tabular numbers-1" four
-Substitution2: "'lnum' lining figures-1" four
+Substitution2: "'tnum' tabular numbers-1" old.4
+Substitution2: "'lnum' lining figures-1" fit.4
 EndChar
 
 StartChar: oldprop.5
@@ -255130,8 +255138,8 @@
 Fore
 Refer: 8012 -1 N 1 0 0 1 -12 0 2
 Validated: 1
-Substitution2: "'tnum' tabular numbers-1" five
-Substitution2: "'lnum' lining figures-1" five
+Substitution2: "'tnum' tabular numbers-1" old.5
+Substitution2: "'lnum' lining figures-1" fit.5
 EndChar
 
 StartChar: oldprop.6
@@ -255142,8 +255150,8 @@
 Fore
 Refer: 8013 -1 N 1 0 0 1 1 0 2
 Validated: 1
-Substitution2: "'tnum' tabular numbers-1" six
-Substitution2: "'lnum' lining figures-1" six
+Substitution2: "'tnum' tabular numbers-1" old.6
+Substitution2: "'lnum' lining figures-1" fit.6
 EndChar
 
 StartChar: oldprop.7
@@ -255154,8 +255162,8 @@
 Fore
 Refer: 23 55 N 1 0 0 1 0 -212 2
 Validated: 1
-Substitution2: "'tnum' tabular numbers-1" seven
-Substitution2: "'lnum' lining figures-1" seven
+Substitution2: "'tnum' tabular numbers-1" old.7
+Substitution2: "'lnum' lining figures-1" fit.7
 EndChar
 
 StartChar: oldprop.8
@@ -255166,8 +255174,8 @@
 Fore
 Refer: 8015 -1 N 1 0 0 1 -21 0 2
 Validated: 1
-Substitution2: "'tnum' tabular numbers-1" eight
-Substitution2: "'lnum' lining figures-1" eight
+Substitution2: "'tnum' tabular numbers-1" old.8
+Substitution2: "'lnum' lining figures-1" fit.8
 EndChar
 
 StartChar: uni037c
@@ -265819,9 +265827,8 @@
 Fore
 Refer: 17 49 N 1 0 0 1 -96 0 2
 Validated: 1
-Substitution2: "'lnum' lining figures-1" one
 Substitution2: "'tnum' tabular numbers-1" one
-Substitution2: "'onum' oldstyle figures-1" old.1
+Substitution2: "'onum' oldstyle figures-1" oldprop.1
 EndChar
 
 StartChar: fit.2
@@ -265832,9 +265839,8 @@
 Fore
 Refer: 18 50 S 1 0 0 1 -10 0 2
 Validated: 1
-Substitution2: "'lnum' lining figures-1" two
 Substitution2: "'tnum' tabular numbers-1" two
-Substitution2: "'onum' oldstyle figures-1" old.2
+Substitution2: "'onum' oldstyle figures-1" oldprop.2
 EndChar
 
 StartChar: fit.3
@@ -265845,9 +265851,8 @@
 Fore
 Refer: 19 51 N 1 0 0 1 -13 0 2
 Validated: 1
-Substitution2: "'lnum' lining figures-1" three
 Substitution2: "'tnum' tabular numbers-1" three
-Substitution2: "'onum' oldstyle figures-1" old.3
+Substitution2: "'onum' oldstyle figures-1" oldprop.3
 EndChar
 
 StartChar: fit.4
@@ -265858,9 +265863,8 @@
 Fore
 Refer: 20 52 S 1 0 0 1 8 0 2
 Validated: 1
-Substitution2: "'lnum' lining figures-1" four
 Substitution2: "'tnum' tabular numbers-1" four
-Substitution2: "'onum' oldstyle figures-1" old.4
+Substitution2: "'onum' oldstyle figures-1" oldprop.4
 EndChar
 
 StartChar: fit.5
@@ -265871,9 +265875,8 @@
 Fore
 Refer: 21 53 N 1 0 0 1 -12 0 2
 Validated: 1
-Substitution2: "'lnum' lining figures-1" five
 Substitution2: "'tnum' tabular numbers-1" five
-Substitution2: "'onum' oldstyle figures-1" old.5
+Substitution2: "'onum' oldstyle figures-1" oldprop.5
 EndChar
 
 StartChar: threetenths
@@ -265932,8 +265935,8 @@
 Fore
 Refer: 8016 -1 N 1 0 0 1 5 0 2
 Validated: 1
-Substitution2: "'tnum' tabular numbers-1" nine
-Substitution2: "'lnum' lining figures-1" nine
+Substitution2: "'tnum' tabular numbers-1" old.9
+Substitution2: "'lnum' lining figures-1" fit.9
 EndChar
 
 StartChar: zeroslashed
Index: FreeSerif.sfd
===================================================================
--- FreeSerif.sfd	(révision 2528)
+++ FreeSerif.sfd	(copie de travail)